//This work is licensed under a Creative Commons Attribution 3.0 Unported License.
//Original version by Daniel Davis, 2013
//danieldavis.com

import geomerative.*;

class ch4 extends ch_abstract
{
  public void ch4()
  {
  }

  @Override
  public void alphabet(String fileName)
  {
    setup();
    
    fill(0);
    for(int i = 0; i < words.length; i++)
    {
      pushMatrix();
      translate( width/2, step_size * (i+1));
      font.draw(words[i]);
      popMatrix();
    }
      
    //blur edges of font.
    filter(BLUR, 4);
      
    PImage background = get();//copy whatever is in the background of sketch into memory...
    background(255);
      
    beginPDFRecord(fileName);
    
    int no_of_layers = 20;
    int points_per_layer = 2000;
    int points_final_layer = 50000;
    float spread = 20;

    
    for(int layer = 0; layer < no_of_layers; layer++)
    {
      pushMatrix();
      translate( random(-spread, spread), random(-spread, spread));
      
      int points_on_this_layer = points_per_layer;
      if(layer == no_of_layers - 1) points_on_this_layer = 100000; //for final layer put in heaps of points. 
      
      float size = (no_of_layers-layer) * 0.5 + 2;
      
      for(int i = 0; i < points_on_this_layer; i++)
      {
        float x = random(width);
        float y = random(height);
        
        color color_point = background.get((int)x,(int)y);
        float brightness = (255 - brightness(color_point)) * layer/(float)no_of_layers;
        
        if(brightness > 55)
        {
          color c = colorMix(layer/(float)no_of_layers + random(-0.4,0.4));
          fill(c, brightness);
          stroke(c, brightness);

          ellipse(x, y, size, size);
          strokeWeight(0);
        }
      }
      popMatrix();
    }
    
    endPDFRecord();
  }
}
