//This work is licensed under a Creative Commons Attribution 3.0 Unported License.
//Original version by Daniel Davis, 2013
//danieldavis.com

import geomerative.*;

class ch8 extends ch_abstract
{
  public void ch8()
  {
  }

  @Override
  public void alphabet(String fileName)
  {
    setup();
   
    RCommand.setSegmentStep(1);
    RCommand.setSegmentator(RCommand.UNIFORMSTEP);
        
    //other ways to divide letter:
    //RCommand.setSegmentLength(9);
    //RCommand.setSegmentator(RCommand.UNIFORMLENGTH);
        
    //RCommand.setSegmentAngle(parent.random(0,0.3f));
    //RCommand.setSegmentator(RCommand.ADAPTATIVE);
    
    beginPDFRecord(fileName);
    
    for(int i = 0; i < words.length; i++)
    {
      pushMatrix();
        translate( width/2, step_size * (i+1));
        
        RGroup grp = font.toGroup(words[i]);
        color c = colorMix(i/(float)words.length);
        
        scribble(grp, c);
        draw_dots(grp);
      popMatrix();
    }
    
    endPDFRecord();
  }
  
  private void draw_dots(RGroup grp)
  {
    float dot_size_pixels = 4;
    RPoint[] pnts = grp.getPoints();
    //draw dots.
    strokeWeight(1);
    stroke(blue);
    
    for(int i = 0; i < pnts.length; i++)
    {
      ellipse(pnts[i].x, pnts[i].y, dot_size_pixels, dot_size_pixels);
    }
  }
  
  
  private void scribble(RGroup grp, color c)
  {
    beginShape();
    stroke(c);
    noFill();
    strokeWeight(1);
    grp = grp.toPolygonGroup();
    RGeomElem[] g = grp.elements;
    
    for(int i = 0; i < g.length; i++)
    {
      RGeomElem elem = g[i];
      RPoint[] pnts = elem.getPoints();
      
      for(int j = 0; j < 20; j++)
      {
        int point = (int) (Math.floor(Math.random() * pnts.length));
        for(int k = point+1; k < point+5 && k < pnts.length; k++)
        {
          curveVertexFromPoint(pnts[k]);
        }
      }
    }
    endShape();
  }
}
