//This work is licensed under a Creative Commons Attribution 3.0 Unported License.
//Original version by Daniel Davis, 2013
//danieldavis.com

import geomerative.*;

class ch9 extends ch_abstract
{
  public void ch9()
  {
  }

  ////////////////////////////////////////////////////////
  //  Main functions
  ////////////////////////////////////////////////////////

  @Override
  public void alphabet(String fileName)
  {
    setup();
    
    beginPDFRecord(fileName);
    for(int i = 0; i < words.length; i++)
    {
      pushMatrix();
      float offset_y = step_size * (i+1);
      translate( width/2, offset_y);
      weave_over_text(words[i], offset_y);
      popMatrix();
    }
    endPDFRecord();
  }
  
  
  private void weave_over_text(String text, float offset_y)
  {
    int num_of_lines = 200;
    int starting_spread = (int)step_size;   //How far the starting lines are spread on the left-hand side.

    //create text
    RGroup grp = font.toGroup(text);
    RGeomElem[] g = grp.elements;

    //Create a special array to hold the points from the text. [i][j]
    //The first number (i) holds each letter.
    //The second number (j) holds the points for that letter. Note that each letter has the same number of points.
    RPoint[][] points = new RPoint[g.length][num_of_lines];

    for (int i = 0; i < g.length; i++)
    {
      RGeomElem elem = g[i];

      //makes sure the number of points around the edge of each letter is the same.
      float len = elem.getCurveLength() / num_of_lines;
      RCommand.setSegmentLength(len);
      RCommand.setSegmentator(RCommand.UNIFORMLENGTH);

      points[i] = elem.getPoints();
    }


    //beginRecord(fileName);

    //Draw the letters, so they are under the lines.
    fill(color(47, 127, 168, 180));//helper.main.blue);
    noStroke();
    font.draw(text);

    //Draw the lines by passing it through the same point number on each letter.
    strokeWeight(0.5);
    noFill();
    for (int i = 0; i < num_of_lines; i++)
    {
      float start_offset = -starting_spread + i * starting_spread / num_of_lines;
      
      float ratio = (offset_y+ start_offset)/height;//i/ (float)(num_of_lines);
      color c = colorMix(ratio);
      stroke(c);

      beginShape();
      
      //starting point is spread vertically
      curveVertex(-width/2-500, start_offset);
      curveVertex(-width/2, start_offset);

      //pass line through each letter.
      for (int j = 0; j < g.length; j++)
      {
        curveVertex(points[j][i].x, points[j][i].y);
      }

      //pass through a circle at the end to keep the lines together
      ratio = (float)(i/ (float)(num_of_lines) * Math.PI);
      RPoint p1 = new RPoint(width/2 - 100, -50);
      RPoint p6 = pointOnCircle(p1, 40, ratio);
      curveVertexFromPoint(p6);

      //bring to a single point to finish.
      curveVertex(width/2+50, height/2-offset_y);
      curveVertex(width/2+400, height/2-offset_y);

      endShape();
    }
    //endRecord();
  }
}
